#include <stdlib.h>
#include <string.h>
#include <pspkernel.h>

#include <psppower.h>
#include <pspdebug.h>
#include <unistd.h>
#include <sys/stat.h>
#include "luaplayer.h"

#define SIO_IOCTL_SET_BAUD_RATE 1

SceUID irda_fd = -1;


// Move g_dir to the stack and MEET CERTAIN DOOM! If the SceIoDirent is found on the STACK instead of among the globals, the PSP WILL CRASH IN A VERY WEIRD WAY. You have been WARNED.
SceIoDirent g_dir;

static char modulePath[256];

static void setModulePath()
{
	getcwd( modulePath, 256 );
}

extern "C" {
	extern SceUID psploadlib( const char * name, char * init );
	extern void **findFunction( SceUID id, const char * library, const char * name );
	extern int init( lua_State *L);
}

// battery function

static int lua_powerGetBatteryLifePercent(lua_State *L)
{
	if (lua_gettop(L) != 0) return luaL_error(L, "wrong number of arguments");
	lua_pushnumber(L, scePowerGetBatteryLifePercent());
	return 1;
}

static int lua_getFreeMemory(lua_State *L)
{
	if (lua_gettop(L) != 0) return luaL_error(L, "no arguments expected.");
	
	// for a realistic number, try to allocate 1 mb blocks until out of memory
	void* buf[64];
	int i = 0;
	for (i = 0; i < 64; i++) {
		buf[i] = malloc(1024 * 1024);
		if (!buf[i]) break;
	}
	int result = i;
	for (; i >= 0; i--) {
		free(buf[i]);
	}
	lua_pushnumber(L, result * 1024 * 1024);
	return 1;
}

static int lua_Quit(lua_State *L)
{
	if (lua_gettop(L) != 0) return luaL_error(L, "wrong number of arguments");
	sceKernelExitGame();
	return 0;
}

static const luaL_reg System_functions[] = {
  {"powerGetBatteryLifePercent",    lua_powerGetBatteryLifePercent},
  {"getFreeMemory",                 lua_getFreeMemory},
  {"Quit",                          lua_Quit},
  {0, 0}
};
void luaSystem_init(lua_State *L) {
	setModulePath();
	luaL_openlib(L, "System", System_functions, 0);
}

